<?php

require_once 'model/equipo.entidad.php';
require_once 'model/equipo.model.php';
require_once 'model/modelo.entidad.php';
require_once 'model/modelo.model.php';
require_once 'model/repuesto.entidad.php';
require_once 'model/repuesto.model.php';
require_once 'model/detalle_repuesto.model.php';

class EquipoController extends helpers {

    private $equipo_model;
    private $modelo_model;
    private $repuesto_model;
    private $detalle_equipo_repuesto;

    public function __CONSTRUCT() {
        $this->equipo_model = new EquipoModel();
        $this->modelo_model = new ModeloModel();
        $this->repuesto_model = new RepuestoModel();
        $this->detalle_equipo_repuesto = new DetalleRepuestoModel();
    }

    public function Index() {
        $equipos = $this->equipo_model->Listar();
        
        require_once 'view/header.php';
        require_once 'view/webforms/wfaequipo.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.catalogos').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function FrmGuardarEquipo() {
        $modelos = $this->modelo_model->Listar();
        $repuestos = $this->repuesto_model->Listar();
        require_once 'view/webforms/wfaequipoa.php';
    }

    public function FrmEditarEquipo() {
        $equipo = $this->equipo_model->Buscar($_POST['Equipo_Id']);
        $modelos = $this->modelo_model->Listar();
        $repuestos = $this->repuesto_model->Listar();

        $lista_repuestos = $this->detalle_equipo_repuesto->Buscar($_POST['Equipo_Id']);

        foreach ($equipo as $r):
            require_once 'view/webforms/wfaequipoa.php';
        endforeach;
    }

    public function MostrarEquipo() {
        $equipo = $this->equipo_model->Buscar($_POST['Equipo_Id']);
        foreach($equipo as $r):
            if ($r->__get('nEqTipo') == 1) {
                $tipo = "GE";
            } elseif ($r->__get('nEqTipo') == 2) {
                $tipo = "Torre";
            } elseif ($r->__get('nEqTipo') == 3) {
                $tipo = "Compresor";
            } elseif ($r->__get('nEqTipo') == 4) {
                $tipo = "Rodillo compactador";
            }
            echo "
                <tbody>
                    <tr>
                        <td>Activo Fijo</td>
                        <td>". $r->__get('sEqActivoFijo') ."</td>
                    </tr>
                    <tr>
                        <td>Serie</td>
                        <td>". $r->__get('sEqSerie') ."</td>
                    </tr>
                    <tr>
                        <td>Modelo</td>
                        <td>". $r->__get('sEqModelo') ."</td>
                    </tr>
                    <tr>
                        <td>Tipo</td>
                        <td>". $tipo ."</td>
                    </tr>
                    <tr>
                        <td>Satélite</td>
                        <td>" . $r->__get('sEqSatelite') . "</td>
                    </tr>
                    ";
                $equipo_repuestos = $this->detalle_equipo_repuesto->Buscar(($r->__get('Equipo_Id')));
                if (!empty($equipo_repuestos)) {
                    echo '
                        <tr>
                            <td colspan="2">
                                <table class="table table-hover table-bordered">
                                    <thead>
                                        <tr>
                                            <th>Repuestos</th>
                                        </tr>
                                    </thead>
                                    <tbody>';
                                    foreach($equipo_repuestos as $er):
                                        echo '
                                            <tr>
                                                <td>'. $er->__get('sRepNombre') .'</td>
                                            </tr>
                                        ';
                                    endforeach;
                    echo            '</tbody>
                                </table>
                            </td>
                        </tr>
                    ';
                }

                echo "</tbody>
            ";
        endforeach;
    }

    public function GuardarEquipo() {
        $equipo = new Equipo();
        $equipo->__set('Equipo_Id', $_POST['Equipo_Id']);
        $equipo->__set('sEqActivoFijo', $_POST['sEqActivoFijo']);
        $equipo->__set('sEqModelo', $_POST['sEqModelo']);
        $equipo->__set('sEqSerie', $_POST['sEqSerie']);
        $equipo->__set('nEqTipo', $_POST['nEqTipo']);
        $equipo->__set('sEqSatelite', $_POST['sEqSatelite']);
        $equipo->__set('nEqUsuario_Id', $_SESSION['usu_codigo']);
        $_POST['Equipo_Id'] == 0 ? $Equipo_Id = $this->equipo_model->Guardar($equipo) : $this->equipo_model->Editar($equipo);

        if ($_POST['Equipo_Id'] != 0) {
            // eliminar detalle equipo repuesto
            $this->detalle_equipo_repuesto->EliminarByEquipo($_POST['Equipo_Id']);

            if (isset($_POST['dataRepuestos'])) {
                foreach($_POST['dataRepuestos'] as $r):
                    $equipoRepuesto = new EquipoRepuesto();
                    $equipoRepuesto->__set('nEquipo_Id', $equipo->__get('Equipo_Id'));
                    $equipoRepuesto->__set('nRepuesto_Id', (int)$r['Repuesto_Id']);
                    $this->equipo_model->CrearEquipoRepuesto($equipoRepuesto);
                endforeach;
            }
        } else {
            if (isset($_POST['dataRepuestos'])) {
                foreach($_POST['dataRepuestos'] as $r):
                    $equipoRepuesto = new EquipoRepuesto();
                    $equipoRepuesto->__set('nEquipo_Id', $Equipo_Id);
                    $equipoRepuesto->__set('nRepuesto_Id', (int)$r['Repuesto_Id']);
                    $this->equipo_model->CrearEquipoRepuesto($equipoRepuesto);
                endforeach;
            }
        }

        echo '<div class="alert alert-success prod" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <strong>Exito!</strong>, los datos fueron agregados correctamente.
            </div>';
    }

    public function EliminarEquipo() {
        $equipo = new Equipo();
        $equipo->__set('Equipo_Id', $_POST['idEquipo']);
        $this->equipo_model->Eliminar($equipo);
        echo '<script type="text/javascript">window.location="?c=Equipo&a=Index";</script>';
    }

    public function BuscarEquipo() {
        $equipo = $this->equipo_model->BuscarPorActivoFijo($_POST['sActivoFijo']);
        if (empty($equipo)) {
            return;
        }
        echo json_encode($equipo[0]);
    }

    // public function PDFUsuario() {
    //     $datos = $this->usuario_model->Buscar($_POST['idUsuario']);
    //     require_once 'view/webforms/PDF/usuario.php';
    // }

}

?>