<?php

require_once 'model/usuarioapp.entidad.php';
require_once 'model/usuarioapp.model.php';
require_once 'model/progmantenimiento.entidad.php';
require_once 'model/progmantenimiento.model.php';
require_once 'model/equipo.entidad.php';
require_once 'model/equipo.model.php';
require_once 'model/plantilla.entidad.php';
require_once 'model/plantilla.model.php';

class ProgMantenimientoController extends helpers {

    private $programacion_model;
    private $equipo_model;
    private $usuarioapp_model;
    private $plantilla_model;

    public function __CONSTRUCT() {
        $this->programacion_model = new ProgramaciónModel();
        $this->equipo_model = new EquipoModel();
        $this->plantilla_model = new PlantillaModel();
        $this->usuarioapp_model = new UsuarioAppModel();
    }

    public function Index() {
        $programaciones = $this->programacion_model->Listar();

        require_once 'view/header.php';
        require_once 'view/webforms/wfaprogmantenimiento.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function FrmGuardarProgMantenimiento() {
        $equipos = $this->equipo_model->Listar();
        $tecnicos = $this->usuarioapp_model->Listar();
        $plantillas = $this->plantilla_model->Listar();
        $table = $this->programacion_model->ListTableMantenimiento();
        $infoTable = array();

        foreach ($table as $item) {
            if ($item->Mantenimiento == "") {
                // buscar el último contrato del equipo y sacar las horas de operacion
                $res = $this->programacion_model->UltimoContratoxEquipo($item->sEqActivoFijo);
                
                if (!empty($res[0])) {
                    // var_dump($res[0]);
                    // var_dump($item->sEqActivoFijo);
                    $fechaInicio = $res[0]->dConFechaInicio;

                    // $horas = $res[0]->sDetConHorasOperacion;
                    $horas = $res[0]->sDetConHorasOperacion == null ? 250 : $res[0]->sDetConHorasOperacion;
                    $mes = 30;
                    $sgteHoras = 0;
                    $sgteHorasNombre = 'SMP-';

                    switch ($horas) {
                        case $horas < 250:
                                $sgteHorasNombre = $sgteHorasNombre."250";
                                $sgteHoras = 250;
                            break;
                        case $horas > 250 && $horas < 500:
                                $sgteHorasNombre = $sgteHorasNombre."500";
                                $sgteHoras = 500;
                            break;
                        case $horas > 500 && $horas < 750:
                                $sgteHorasNombre = $sgteHorasNombre."250";
                                $sgteHoras = 250;
                            break;
                        case $horas > 750 && $horas < 1000:
                                $sgteHorasNombre = $sgteHorasNombre."1000";
                                $sgteHoras = 1000;
                            break;
                        case $horas > 1000 && $horas < 1250:
                                $sgteHorasNombre = $sgteHorasNombre."250";
                                $sgteHoras = 250;
                            break;
                    }

                    // var_dump($horas);
                    $aux = ($sgteHoras * $mes)/ floatval($horas);
                    $diasAprx =  round($aux);
                    $formatDate = new DateTime($fechaInicio);
                    $formatDate->modify("+$diasAprx day");
                    $finalDate = $formatDate->format("d-m-Y");

                    $item->Estimado = $finalDate;
                    $item->Sgte = $sgteHorasNombre;
                }

                $infoTable[] = $item;
            } else {
                // buscar los último mantenimientos y hacer la estimación
                $mant = $this->programacion_model->UltimosMantenimientoXEquipo($item->Equipo_Id);
                if (count($mant) > 1) {
                    $utlimo = DateTime::createFromFormat('d-m-Y', $mant[0]->dManFecha_Act); #el más reciente
                    $anterior = DateTime::createFromFormat('d-m-Y', $mant[1]->dManFecha_Act);
                    $resta = $utlimo->diff($anterior)->format('%R%a');
                    $intRst = abs($resta);

                    $formatDate = new DateTime($item->dManFecha_Act);
                    $formatDate->modify("+$intRst day");
                    $finalDate = $formatDate->format("d-m-Y");
                    $item->Estimado = $finalDate;
                    

                } else {
                    // poner por defecto un mes más
                    $formatDate = new DateTime($item->dManFecha_Act);
                    $formatDate->modify("+1 month");
                    $finalDate = $formatDate->format("d-m-Y");
                    $item->Estimado = $finalDate;
                }

                $infoTable[] = $item;
            }
        }
        usort($infoTable, function($a, $b) {
            $fechaA = DateTime::createFromFormat('d-m-Y', $a->Estimado);
            $fechaB = DateTime::createFromFormat('d-m-Y', $b->Estimado);
        
            if ($fechaA == $fechaB) {
                return 0;
            }
        
            return ($fechaA < $fechaB) ? -1 : 1;
        });
        // echo '<pre>';
        // var_dump($infoTable);
        // echo '</pre>';
        // exit();
        require_once 'view/webforms/wfaprogmantenimientoa.php';
    }

    // public function compararPorEstimado($a, $b) {
    //     $fechaA = DateTime::createFromFormat('d-m-Y', $a->Estimado);
    //     $fechaB = DateTime::createFromFormat('d-m-Y', $b->Estimado);

    //     if ($fechaA === false || $fechaB === false) {
    //         // Manejar casos en los que la conversión de fecha falla
    //         return 0;
    //     }

    //     echo "Comparando: " . $a->Estimado . " con " . $b->Estimado . "\n";

    //     $diferencia = $fechaA->diff($fechaB);

    //     if ($diferencia->days < 0) {
    //         return -1;
    //     } elseif ($diferencia->days > 0) {
    //         return 1;
    //     } else {
    //         return 0;
    //     }
    // }

    public function FrmEditarProgramacion() {
        $edit = true;
        $programacion = $this->programacion_model->Buscar($_POST['Programacion_Id']);
        $equipos = $this->equipo_model->Listar();
        $tecnicos = $this->usuarioapp_model->Listar();
        $plantillas = $this->plantilla_model->Listar();
        
        $table = $this->programacion_model->ListTableMantenimiento();
        $infoTable = array();
        foreach ($table as $item) {
            if ($item->Mantenimiento == "") {
                // buscar el último contrato del equipo y sacar las horas de operacion
                $res = $this->programacion_model->UltimoContratoxEquipo($item->sEqActivoFijo);
                if (!empty($res[0])) {
                    // var_dump($res[0]);
                    // var_dump($item->sEqActivoFijo);
                    $fechaInicio = $res[0]->dConFechaInicio;

                    // $horas = $res[0]->sDetConHorasOperacion;
                    $horas = $res[0]->sDetConHorasOperacion == null ? 250 : $res[0]->sDetConHorasOperacion;
                    $mes = 30;
                    $sgteHoras = 0;
                    $sgteHorasNombre = 'SMP-';

                    switch ($horas) {
                        case $horas < 250:
                                $sgteHorasNombre = $sgteHorasNombre."250";
                                $sgteHoras = 250;
                            break;
                        case $horas > 250 && $horas < 500:
                                $sgteHorasNombre = $sgteHorasNombre."500";
                                $sgteHoras = 500;
                            break;
                        case $horas > 500 && $horas < 750:
                                $sgteHorasNombre = $sgteHorasNombre."250";
                                $sgteHoras = 250;
                            break;
                        case $horas > 750 && $horas < 1000:
                                $sgteHorasNombre = $sgteHorasNombre."1000";
                                $sgteHoras = 1000;
                            break;
                        case $horas > 1000 && $horas < 1250:
                                $sgteHorasNombre = $sgteHorasNombre."250";
                                $sgteHoras = 250;
                            break;
                    }

                    $aux = ($sgteHoras * $mes)/ floatval($horas);
                    $diasAprx =  round($aux);
                    $formatDate = new DateTime($fechaInicio);
                    $formatDate->modify("+$diasAprx day");
                    $finalDate = $formatDate->format("d-m-Y");

                    $item->Estimado = $finalDate;
                    $item->Sgte = $sgteHorasNombre;
                }

                $infoTable[] = $item;
            } else {
                // buscar los último mantenimientos y hacer la estimación
                $mant = $this->programacion_model->UltimosMantenimientoXEquipo($item->Equipo_Id);
                if (count($mant) > 1) {
                    $utlimo = DateTime::createFromFormat('d-m-Y', $mant[0]->dManFecha_Act); #el más reciente
                    $anterior = DateTime::createFromFormat('d-m-Y', $mant[1]->dManFecha_Act);
                    $resta = $utlimo->diff($anterior)->format('%R%a');
                    $intRst = abs($resta);

                    $formatDate = new DateTime($item->dManFecha_Act);
                    $formatDate->modify("+$intRst day");
                    $finalDate = $formatDate->format("d-m-Y");
                    $item->Estimado = $finalDate;
                    

                } else {
                    // poner por defecto un mes más
                    $formatDate = new DateTime($item->dManFecha_Act);
                    $formatDate->modify("+1 month");
                    $finalDate = $formatDate->format("d-m-Y");
                    $item->Estimado = $finalDate;
                }

                $infoTable[] = $item;
            }
        }
        usort($infoTable, function($a, $b) {
            $fechaA = DateTime::createFromFormat('d-m-Y', $a->Estimado);
            $fechaB = DateTime::createFromFormat('d-m-Y', $b->Estimado);
        
            if ($fechaA == $fechaB) {
                return 0;
            }
        
            return ($fechaA < $fechaB) ? -1 : 1;
        });

        foreach ($programacion as $r):
            require_once 'view/webforms/wfaprogmantenimientoa.php';
        endforeach;
    }

    public function MostrarProgramacion() {
        $programacion = $this->programacion_model->Buscar($_POST['Programacion_Id']);
        foreach ($programacion as $r):
            echo " <tbody>
                          <tr>
                             <td>
                                Fecha
                             </td>
                             <td>" . $r->__GET('dProFecha') . "</td>
                          </tr>
                          <tr>
                             <td>Plantilla</td>
                             <td>" . $r->__GET('sPlaNombre') . "</td>
                          </tr>
                          <tr>
                             <td>Equipo</td>
                             <td>" . $r->__GET('sEqActivoFijo') . "</td>
                          </tr>
                          <tr>
                             <td>Técnico</td>
                             <td>" . $r->__GET('sUsuNombre') . "</td>
                          </tr>
                          <tr>
                             <td>Estado</td>
                             <td>" . ($r->__GET('nProEstado') == '1' ? '<span class="label bg-green">Habilitado</span>' : '<span class="label bg-danger">Inhabilitado</span>') . "</td>
                          </tr>
                       </tbody>
                     ";
        endforeach;
    }

    public function GuardarProgramacion() {
        $programacion = new Programación();
        $programacion->__SET('Programacion_Id', $_POST['Programacion_Id']);
        $programacion->__SET('dProFecha', $_POST['dProFecha']);
        $programacion->__SET('nProEquipo_Id', $_POST['nProEquipo_Id']);
        $programacion->__SET('nProTecnico_Id', $_POST['nProTecnico_Id']);
        $programacion->__SET('nProPlantilla_Id', $_POST['nProPlantilla_Id']);
        $programacion->__SET('nProUsuario_Id', $_SESSION['usu_codigo']);
        $_POST['Programacion_Id'] == 0 ? $this->programacion_model->Guardar($programacion) : $this->programacion_model->Editar($programacion);
        echo '<div class="alert alert-success prod" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <strong>Exito!</strong>, los datos fueron agregados correctamente.
            </div>';
    }

    public function EliminarProgramacion() {
        $programacion = new Programación();
        $programacion->__SET('Programacion_Id', $_POST['idProgramacion']);
        $this->programacion_model->Eliminar($programacion);
        echo '<script type="text/javascript">window.location="?c=ProgMantenimiento&a=Index";</script>';
    }

    // public function PDFUsuario() {
    //     $datos = $this->usuario_model->Buscar($_POST['idUsuario']);
    //     require_once 'view/webforms/PDF/usuario.php';
    // }

}

?>