<?php

class ContratoModel {
    private $pdo;

    public function __construct()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL con_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $contrato = new Contrato();
                $contrato->__SET('Contrato_Id', $r->Contrato_Id);
                $contrato->__SET('sConNumero', $r->sConNumero);
                $contrato->__SET('nConCliente_Id', $r->nConCliente_Id);
                $contrato->__SET('dConFecha', $r->dConFecha);
                $contrato->__SET('dConFechaInicio', $r->dConFechaInicio);
                $contrato->__SET('dConFechaTermino', $r->dConFechaTermino);
                $contrato->__SET('dConFecha_Act', $r->dConFecha_Act);
                $contrato->__SET('nConUsuario_Id', $r->nConUsuario_Id);
                $contrato->__SET('nConEstado', $r->nConEstado);
                $contrato->__SET('nConEliminado', $r->nConEliminado);

                $contrato->__SET('sCliNombre', $r->sCliNombre);
                $result[] = $contrato;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($Contrato_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL con_listar($Contrato_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $contrato = new Contrato();
                $contrato->__SET('Contrato_Id', $r->Contrato_Id);
                $contrato->__SET('sConNumero', $r->sConNumero);
                $contrato->__SET('nConCliente_Id', $r->nConCliente_Id);
                $contrato->__SET('dConFecha', $r->dConFecha);
                $contrato->__SET('dConFechaInicio', $r->dConFechaInicio);
                $contrato->__SET('dConFechaTermino', $r->dConFechaTermino);
                $contrato->__SET('sConPeriodoAlquiler', $r->sConPeriodoAlquiler);
                $contrato->__SET('dConFecha_Act', $r->dConFecha_Act);
                $contrato->__SET('nConUsuario_Id', $r->nConUsuario_Id);
                $contrato->__SET('nConEstado', $r->nConEstado);
                $contrato->__SET('nConEliminado', $r->nConEliminado);
                $contrato->__SET('sConSucursal', $r->sConSucursal);
                $contrato->__SET('sConUbicacion', $r->sConUbicacion);

                $contrato->__SET('sCliNombre', $r->sCliNombre);
                $result[] = $contrato;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Guardar(Contrato $contrato) {
        try {
            $Contrato_Id = 0;
            $stm = $this->pdo->prepare("CALL con_crear(?,?,?,?,?,?,?,?,?,@pContrato_Id)");
            $stm->execute(array(
                $contrato->__GET('sConNumero'),
                $contrato->__GET('nConCliente_Id'),
                $contrato->__GET('dConFecha'),
                $contrato->__GET('dConFechaInicio'),
                $contrato->__GET('dConFechaTermino'),
                $contrato->__GET('sConPeriodoAlquiler'),
                $contrato->__GET('nConUsuario_Id'),
                $contrato->__GET('sConSucursal'),
                $contrato->__GET('sConUbicacion')
            ));
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $Contrato_Id = $r->Contrato_Id;
            endforeach;
            return $Contrato_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(Contrato $contrato) {
        try {
            $stm = $this->pdo->prepare("CALL con_editar(?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                $contrato->__GET('sConNumero'),
                $contrato->__GET('nConCliente_Id'),
                $contrato->__GET('dConFecha'),
                $contrato->__GET('dConFechaInicio'),
                $contrato->__GET('dConFechaTermino'),
                $contrato->__GET('sConPeriodoAlquiler'),
                $contrato->__GET('nConUsuario_Id'),
                $contrato->__GET('Contrato_Id'),
                $contrato->__GET('sConSucursal'),
                $contrato->__GET('sConUbicacion')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(Contrato $contrato) {
        try {
            $stm = $this->pdo->prepare("CALL con_eliminar(?)");
            $stm->execute(array(
                $contrato->__GET('Contrato_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function CrearDetalleContrato(DetalleContrato $detalle) {
        try {
            $stm = $this->pdo->prepare("CALL con_det_crear(?,?,?,?,?,?)");
            $stm->execute(array(
                $detalle->__get('nContrato_Id'),
                $detalle->__get('sDetConCodigo'),
                $detalle->__get('sDetConSerie'),
                $detalle->__get('sDetConTipo'),
                $detalle->__get('sDetConUbicacion'),
                $detalle->__get('sDetConHorasOperacion')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}