<?php

class PlantillaModel {
    private $pdo;

    public function __construct()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL pla_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $plantilla = new Plantilla();
                $plantilla->__set('Plantilla_Id', $r->Plantilla_Id);
                $plantilla->__set('sPlaNombre', $r->sPlaNombre);
                $plantilla->__set('nPlanTipo', $r->nPlanTipo);
                $plantilla->__set('Tipo', $r->Tipo);
                $result[] = $plantilla;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($Plantilla_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL pla_listar($Plantilla_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $plantilla = new Plantilla();
                $plantilla->__set('Plantilla_Id', $r->Plantilla_Id);
                $plantilla->__set('sPlaNombre', $r->sPlaNombre);
                $plantilla->__set('nPlanTipo', $r->nPlanTipo);
                $result[] = $plantilla;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Guardar(Plantilla $plantilla)
    {
        try {
            $Plantilla_Id = 0;
            $stm = $this->pdo->prepare("CALL pla_crear(?,@pPlantilla_Id,?,?)");
            $stm->execute(array(
                $plantilla->__get('sPlaNombre'),
                $plantilla->__get('nPlaUsuario_Id'),
                $plantilla->__get('nPlanTipo')
            ));
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $Plantilla_Id = $r->Plantilla_Id;
            endforeach;
            return $Plantilla_Id;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(Plantilla $plantilla)
    {
        try {
            $stm = $this->pdo->prepare("CALL pla_editar(?,?,?,?)");
            $stm->execute(array(
                $plantilla->__get('sPlaNombre'),
                $plantilla->__get('Plantilla_Id'),
                $plantilla->__get('nPlaUsuario_Id'),
                $plantilla->__get('nPlanTipo')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(Plantilla $plantilla)
    {
        try {
            $stm = $this->pdo->prepare("CALL pla_eliminar(?)");
            $stm->execute(array(
                $plantilla->__get('Plantilla_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function CrearDetalleTarea(TareaDetalle $detalle) {
        try {
            $stm = $this->pdo->prepare("CALL crear_detalle_tarea(?,?)");
            $stm->execute(array(
                $detalle->__get('nPlantilla_Id'),
                $detalle->__get('nTarea_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function CrearDetalleRepuesto(RepuestoDetalle $detalle) {
        try {
            $stm = $this->pdo->prepare("CALL crear_detalle_repuesto(?,?)");
            $stm->execute(array(
                $detalle->__get('nPlantilla_Id'),
                $detalle->__get('nRepuesto_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

}