<?php

class RepuestoModel {
    private $pdo;

    public function __construct()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        }
        catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rep_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $repuesto = new Repuesto();
                $repuesto->__SET('Repuesto_Id', $r->Repuesto_Id);
                $repuesto->__SET('sRepCodigo', $r->sRepCodigo);
                $repuesto->__SET('sRepNombre', $r->sRepNombre);
                $repuesto->__SET('nRepEliminado', $r->nRepEliminado);
                $result[] = $repuesto;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($Repuesto_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rep_listar($Repuesto_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $repuesto = new Repuesto();
                $repuesto->__SET('Repuesto_Id', $r->Repuesto_Id);
                $repuesto->__SET('sRepCodigo', $r->sRepCodigo);
                $repuesto->__SET('sRepNombre', $r->sRepNombre);
                $repuesto->__SET('nRepEliminado', $r->nRepEliminado);
                $result[] = $repuesto;
            }
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Guardar(Repuesto $repuesto)
    {
        try {
            $stm = $this->pdo->prepare("CALL rep_crear(?,?,?)");
            $stm->execute(array(
                $repuesto->__GET('sRepCodigo'),
                $repuesto->__GET('sRepNombre'),
                $repuesto->__GET('nRepUsuario_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(Repuesto $repuesto)
    {
        try {
            $stm = $this->pdo->prepare("CALL rep_editar(?,?,?,?,?)");
            $stm->execute(array(
                $repuesto->__GET('sRepCodigo'),
                $repuesto->__GET('sRepNombre'),
                $repuesto->__GET('nRepEliminado'),
                $repuesto->__GET('Repuesto_Id'),
                $repuesto->__GET('nRepUsuario_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(Repuesto $repuesto)
    {
        try {
            $stm = $this->pdo->prepare("CALL rep_eliminar(?)");
            $stm->execute(array(
                $repuesto->__GET('Repuesto_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}