<?php

class UsuarioModel {

    private $pdo;

    public function __CONSTRUCT() {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL usu_listar(0)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Usuario();
                $usu->__SET('Usuario_Id', $r->Usuario_Id);
                $usu->__SET('Personal_Id', $r->Personal_Id);
                $usu->__SET('sUsuNombre', $r->sUsuNombre);
                $usu->__SET('sUsuLogin', $r->sUsuLogin);
                $usu->__SET('sUsuContrasena', $r->sUsuContrasena);
                $usu->__SET('nUsuTipo', $r->nUsuTipo);
                $usu->__SET('nUsuEstado', $r->nUsuEstado);
                $usu->__SET('nUsuEliminado', $r->nUsuEliminado);
                $usu->__SET('dUsuFecha_Act', $r->dUsuFecha_Act);
                $usu->__SET('nUsuUsuarioOwn_Id', $r->nUsuUsuarioOwn_Id);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarUsuariosApp() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL usuapp_listar(0)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Usuario();
                $usu->__SET('Usuario_Id', $r->Usuario_Id);
                $usu->__SET('sUsuPassword', $r->sUsuPassword);
               
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($Usuario_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL usu_listar($Usuario_Id)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Usuario();
                $usu->__SET('Usuario_Id', $r->Usuario_Id);
                $usu->__SET('Personal_Id', $r->Personal_Id);
                $usu->__SET('sUsuNombre', $r->sUsuNombre);
                $usu->__SET('sUsuLogin', $r->sUsuLogin);
                $usu->__SET('sUsuContrasena', $r->sUsuContrasena);
                $usu->__SET('nUsuTipo', $r->nUsuTipo);
                $usu->__SET('nUsuEstado', $r->nUsuEstado);
                $usu->__SET('nUsuEliminado', $r->nUsuEliminado);
                $usu->__SET('dUsuFecha_Act', $r->dUsuFecha_Act);
                $usu->__SET('nUsuUsuarioOwn_Id', $r->nUsuUsuarioOwn_Id);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function autenticar($Usuario, $Clave) {
		
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL usu_autentica('" . $Usuario . "','" . $Clave . "');");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Usuario();
                $usu->__SET('Usuario_Id', $r->Usuario_Id);
                $usu->__SET('Personal_Id', $r->Personal_Id);
                $usu->__SET('sUsuNombre', $r->sUsuNombre);
                $usu->__SET('sUsuLogin', $r->sUsuLogin);
                $usu->__SET('sUsuContrasena', $r->sUsuContrasena);
                $usu->__SET('nUsuTipo', $r->nUsuTipo);
                $usu->__SET('nUsuEstado', $r->nUsuEstado);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(Usuario $data) {
        try {
            $stm = $this->pdo->prepare("CALL usu_crear(?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('Personal_Id'),
                $data->__get('sUsuNombre'),
                $data->__get('sUsuLogin'),
                $data->__get('sUsuContrasena'),
                $data->__get('nUsuTipo'),
                $data->__get('nUsuEstado'),
                $data->__get('nUsuEliminado'),
                $data->__get('nUsuUsuarioOwn_Id'),
                $data->__get('sUsuCodigosap')
            ));
            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>	<i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                    La informacion fue registrada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            echo '<div class="alert alert-danger" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Error!</strong>,' . $e->getMessage() . '.
                  </div>';
        }
    }

    public function Editar(Usuario $data) {
        try {
            $stm = $this->pdo->prepare("CALL usu_editar(?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('Personal_Id'),
                $data->__get('sUsuNombre'),
                $data->__get('sUsuLogin'),
                $data->__get('sUsuContrasena'),
                $data->__get('nUsuTipo'),
                $data->__get('nUsuEstado'),
                $data->__get('nUsuEliminado'),
                $data->__get('nUsuUsuarioOwn_Id'),
                $data->__get('Usuario_Id'),
                $data->__get('sUsuCodigosap')
            ));
            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>	<i class="icon fa fa-check"></i> Informacion Modificada.</h4>
                    La informacion fue modificada satisfactoriamente.
                  </div>';
            echo '<script type="text/javascript">window.location="?c=Usuario&a=Index";</script>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Claves(Usuario $data) {
        try {
            $stm = $this->pdo->prepare("CALL usu_claves(?,?)");
            $stm->execute(array(
                $data->__get('Usuario_Id'),
                $data->__get('sUsuContrasena')
            ));
            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>	<i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                    La informacion fue guardada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ClavesClientes(Clientes $data) {
        try {
            $stm = $this->pdo->prepare("CALL usu_clavesClientes(?,?)");
            $stm->execute(array(
                $data->__get('Cliente_Id'),
                $data->__get('sCliPassword')
            ));
            echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>	<i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                    La informacion fue guardada satisfactoriamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Eliminar(Usuario $data) {
        try {
            $stm = $this->pdo->prepare("CALL usu_eliminar(?)");
            $stm->execute(array($data->__get('Usuario_Id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Estado(Usuario $data) {
        try {
            $stm = $this->pdo->prepare("CALL usu_estado(?,?)");
            $stm->execute(array($data->__get('Usuario_Id'), $data->__get('nUsuEstado')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Disabled($usuario) {
        try {
            $stm = $this->pdo->prepare("CALL usu_disabled('$usuario')");
            $stm->execute();
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

}
