jQuery.validator.addMethod("letras", function (value, element) {
    return this.optional(element) || /^[a-záéóóúàèìòùäëïöüñ\s]+$/i.test(value);
});
jQuery.validator.addMethod("decimales", function (value, element) {
    return this.optional(element) || /^([,0-9]+\.+[0-9]|[0-9])+$/.test(value);
});
jQuery.validator.addMethod("fecha", function (value, element) {
    return this.optional(element) || /^([0-9]{2}\/[0-9]{2}\/[0-9]{4})$/.test(value);
});
jQuery.validator.addMethod("password_modasa", function (value, element) {
    return this.optional(element) || /^(?=.*[a-zA-Z])(?=.*\d)(?=.*[$@$!%*?&#.$($)$-$_])([A-Za-z\d$@$!%*?&#.$($)$-$_]|[^ ]){6,8}$/.test(value);
//    return this.optional(element) || /^[A-zA-Z]\w{6,8}$/.test(value);
});
//


$("#FrmContrato").validate({
    errorClass: 'error',
    rules: {
        sConNumero: {
            required: true
        },
        nConCliente_Id: {
            required: true
        },
        dConFecha: {
            required: true
        },
        // dConFechaInicio: {
        //     required: true
        // },
        // dConFechaTermino: {
        //     required: true
        // },
        // dConPeriodoAlquiler: {
        //     required: true
        // }
    },
    messages: {
        sConNumero: {
            required: "Ingrese un número de contrato."
        },
        nConCliente_Id: {
            required: "Seleccione un cliente."
        },
        dConFecha: {
            required: "Ingresa la fecha."
        },
        // dConFechaInicio: {
        //     required: true
        // },
        // dConFechaTermino: {
        //     required: true
        // },
        // dConPeriodoAlquiler: {
        //     required: true
        // }
    }
})
$("#FrmProgramacion").validate({
    errorClass: 'error',
    rules: {
        dProFecha: {
            required: true
        },
        nProEquipo_Id: {
            required: true
        },
        nProTecnico_Id: {
            required: true
        },
        nProCliente_Id: {
            required: true
        },
        nProPlantilla_Id: {
            required: true
        }

    },
    messages: {
        dProFecha: {
            required: "Seleccione fecha."
        },
        nProEquipo_Id: {
            required: "Seleccione un equipo."
        },
        nProTecnico_Id: {
            required: "Seleccione un técnico."
        },
        nProCliente_Id: {
            required: "Seleccione un cliente."
        },
        nProPlantilla_Id: {
            required: "Seleccione una plantilla."
        }
    }
})

$("#FrmPlantilla").validate({
    errorClass: 'error',
    rules: {
        sPlaNombre: {
            required: true
        },
        nPlaTipoId: {
            required: true
        }
    },
    messages: {
        sPlaNombre: {
            required: "Ingrese nombre de plantilla."
        },
        nPlaTipoId: {
            required: 'Seleccione un tipo.'
        }
    }
})
$("#FrmEquipos").validate({
    errorClass: 'error',
    rules: {
        sEqActivoFijo: {
            required: true
        },
        nEqModelo: {
            required: true
        },
        sEqSerie: {
            required: true
        },
        nEqTipo: {
            required: true
        }
    },
    messages: {
        sEqActivoFijo: {
            required: "Ingrese nombre del equipo."
        },
        nEqModelo: {
            required: "Seleccione un modelo."
        },
        sEqSerie: {
            required: "Ingrese una serie."
        },
        nEqTipo: {
            required: "Seleccione un tipo."
        }
    }
})
$("#FrmRepuestos").validate({
    errorClass: 'error',
    rules: {
        sRepCodigo: {
            required: true
        },
        sRepNombre: {
            required: true
        }
    },
    messages: {
        sRepCodigo: {
            required: "Ingrese código."
        },
        sRepNombre: {
            required: "Ingrese nombre del repuesto."
        }
    }
})
$("#FrmTareas").validate({
    errorClass: 'error',
    rules: {
        sTarCodigo: {
            required: true
        },
        sTarNombre: {
            required: true
        },
    },
    messages: {
        sTarCodigo: {
            required: 'Ingrese código.'
        },
        sTarNombre: {
            required: 'Ingrese nombre de la tarea.'
        },
    }
})
$("#FrmClientes").validate({
    errorClass: 'error',
    rules: {    
        sCliCodigo: {
            required: true,
            maxlength: 50
        },
        sCliNombre: {
            required: true,
            maxlength: 70          
        },
        sCliRUCDNI: {
            required: true,
            digits: true,
            maxlength: 12,
            minlength: 8
        },
        sCliTelefono: {
            digits: true
        },
        sCliContacto: {
            required: true,
            maxlength: 70
        },
			sCliCorreo: {
            required: true,
            maxlength: 200
        }  		/*,
        sCliUsuario: {
            required: true,
            maxlength: 100
        },
        sCliPassword: {
            required: true,
            maxlength: 100
        },
        nCliEstado: {
            required: true
        } */
    },
    messages: {  
        sCliCodigo: {
            required: "Ingrese Codigo.",
            maxlength: "Maxmimo 50 Caracteres."
        },
        sCliNombre: {
            required: "Ingrese nombre.",
            maxlength: "Maximo 50 Caracteres."          
        },
        sCliRUCDNI: {
            required: "Ingrese DNI/RUC.",
            digits: "Permitido solo numeros.",
            maxlength: "Maximo 12 Caracteres.",
            minlength: "Minimo 8 Caracteres."
        },
        sCliTelefono: {
            required: "Ingrese Telefono 1.",
            digits: "Permitido solo numeros.",
            maxlength: "Maximo 12 Caracteres.",
            minlength: "Minimo 8 Caracteres."
        },
        sCliContacto: {
            required: "Ingrese Contacto."
        },
        sCliCorreo: {
            required: "Ingrese Conrreo."
        }  
		/*,
        sCliUsuario: {
            required: "Ingrese Usuario.",
            maxlength: "MAximo 100 Caracteres."
        },
        sCliPassword: {
            required: "Ingrese Password.",
            maxlength: "Maximo 100 Caracteres."
        },
        nCliEstado: {
            required: "Seleccione Estado."
        } */
    }
});

$("#formCompetencia").validate({
    errorClass: 'error',
    rules: {    
        sComNombre: {
            required: true,
            maxlength: 45
        },         
        sComTipo: {
            required: true
        },
    },
    messages: {     
        sComNombre: {
            required: "Ingrese Competencia.",
            maxlength: "Maximo 45 Caracteres"
        },
        sComTipo: {
            required: "Seleccione tipo"
        }
    }
    
});


$("#FrmPersonal").validate({
    
    errorClass: 'error',
    rules: {    
        sPerApePaterno: {
            required: true,
            maxlength: 45
        },
        sPerApeMaterno: {
            required: true,
            maxlength: 45
        },
        sPerNombres: {
            required: true,
            maxlength: 45
        },
        sPerDNI:{
            required: true, //"Ingrese DNI/RUC.",
            digits: true, //"Permitido solo numeros.",
            maxlength: 8, //"Maximo 8 Caracteres.",
            minlength: 8 //"Minimo 8 Caracteres."
        },
        sPerCargo:{
            required: true
        },
        nPerEstado:{
            required: true
        }
    },
    messages: {  
        sPerApePaterno: {
            required: "Ingrese Apellido Paterno",
            maxlength: "Maximo 45 Caracteres."
        },
        sPerApeMaterno: {
            required: "Ingrese Apellido Materno.",
            maxlength: "Maximo 45 Caracteres."
        },
        sPerNombres: {
            required: "Ingrese Nombres.",
            maxlength: "Maximo 45 Caracteres."
        },
        sPerDNI:{
            required: "Ingrese DNI/RUC.",
            digits: "Permitido solo numeros.",
            maxlength: "Maximo 8 Caracteres.",
            minlength: "Minimo 8 Caracteres."
        },
        sPerCargo:{
            required: "Ingrese Cargo.",
        },
        nPerEstado:{
            required: "Seleccione Estado"
        }
    }
});

$("#FrmBien").validate({
    errorClass: 'error',
    rules: {        
        sBienPlaca: {            
           required: true
        },
        sBienCategoria: {
            required: true
        },
        sBienMarca: {
            required: true
        },
        sBienModelo: {
            required: true
        },
        sBienAnioFabricacion: {
            required: true,
            digits: true
        },
        sBienVINSeria: {
            required: true
        },
        sBienCombustible: {
            required: true
        },
        sBienNumeroMotor: {
            required: true
        },
        nBienNumeroRuedas: {
            required: true,
            digits: true
        },
        nBienEstado: {
            required: true
        }
    },
    messages: {        
        sBienPlaca: "Ingrese placa de rodaje.",
        sBienCategoria: "Ingrese categoria",
        sBienMarca: "Ingrese marca.",
        sBienModelo: "Ingrese modelo",
        sBienAnioFabricacion: {
            required: "Ingrese año de fabricacion",
            digits: "Ingrese solo numeros."
        },
        sBienVINSeria: "Ingrese VIN/serie",
        sBienCombustible: "Ingrese combustible.",
        sBienNumeroMotor: "Ingrese numero de motor.",
        nBienNumeroRuedas: {
            required: "Ingrese numero de eje",
            digits: "Ingrese solo numeros"
        },
        nBienEstado: "Ingrese estado por favor"
    }
});
$("#FrmGarantiasM").validate({
    errorClass: 'error',
    rules: {        
        Notaria_IdM: {            
           required: true
        },
        sMobCiudadM: {
            required: true
        },
        sGarNroNotariaM: {
//            required: true,
            digits: true
        },
        dGarFechaM: {
            required: true
        },
        dMobValorBienM: {
            required: true,
            decimales: true
        },
        dGarFinancimientoM: {
//            required: true,
            decimales: true
        },
        dGarValorAfectacionM: {
//            required: true,
            decimales: true
        },
        dGarValorConvecionalM: {
//            required: true,
            decimales: true
        },
        nGarTipomonedaM: {
            required: true
        },
        nGarEstadoM: {
            required: true
        }
    },
    messages: {        
        Notaria_IdM: "Seleccione Notaria.",
        sMobCiudadM: "Seleccione ciudad.",
        sGarNroNotariaM: {
//            required: "Ingrese numero de garantia notaria.",
            digits: "Ingrese solo numeros."
        },
        dGarFechaM: "Ingrese fecha.",
        dMobValorBienM: {
            required: "Ingrese valor del bien.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarFinancimientoM: {
//            required: "Ingrese financiamiento.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarValorAfectacionM: {
//            required: "Ingrese valor de afectacion.",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        dGarValorConvecionalM: {
//            required: "Ingrese valor convesional",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarTipomonedaM: "Seleccione tipo de moneda.",
        nGarEstadoM: "Seleccione estado"
    }
});
$("#FrmGarantiasI").validate({
    errorClass: 'error',
    rules: {        
        Notaria_IdI: {            
           required: true
        },
        sInmCiudadI: {
            required: true
        },
        sGarNroNotariaI: {
            digits: true
        },
        dGarFechaI: {
            required: true
        },
        dInmValorBienI: {
            required: true,
            decimales: true
        },
        dGarFinancimientoI: {
            required: true,
            decimales: true
        },
        dGarValorAfectacionI: {
            required: true,
            decimales: true
        },
        nGarTipomonedaI: {
            required: true
        },
        dGarValorConvecionalI: {
            required: true,
            decimales: true
        },
        nGarEstadoM: {
            required: true
        },
        sInmDepartamentoI: {
            required: true
        },
        sInmProvinciaI: {
            required: true
        },
        sInmDistritoI: {
            required: true
        },
        nGarEstadoI: {
            required: true
        }
    },
    messages: {        
        Notaria_IdI: "Seleccione Notaria.",
        sInmCiudadI: "Seleccione ciudad.",
        sGarNroNotariaI: {
            required: "Ingrese numero de garantia notaria.",
            digits: "Ingrese solo numeros."
        },
        dGarFechaI: "Ingrese fecha.",
        dInmValorBienI: {
            required: "Ingrese valor del bien.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarFinancimientoI: {
            required: "Ingrese financiamiento.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarValorAfectacionI: {
            required: "Ingrese valor de afectacion.",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarTipomonedaI: "Seleccione tipo de moneda.",
        dGarValorConvecionalI: {
            required: "Ingrese valor convesional",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarEstadoM: "Seleccione estado",
        sInmDepartamentoI: "Seleccione departamento.",
        sInmProvinciaI: "Seleccione provincia.",
        sInmDistritoI: "Seleccione distrito",
        nGarEstadoI: "Seleccione estado"
    }
});
$("#FrmGarantiasO").validate({
    errorClass: 'error',
    rules: {        
        Notaria_IdO: {            
           required: true
        },
        nOtrTipoO: {
            required: true
        },
        sGarNroNotariaO: {
            digits: true
        },
        dGarFechaO: {
            required: true
        },
        nOtrMontoGarantizadoO: {
            required: true,
            decimales: true
        },
        dGarFinancimientoO: {
            required: true,
            decimales: true
        },
        dGarValorAfectacionO: {
            required: true,
            decimales: true
        },
        nGarTipomonedaO: {
            required: true
        },
        dGarValorConvecionalO: {
            required: true,
            decimales: true
        },
        nOtrRegistradoO: {
            required: true
        },
        nGarEstadoO: {
            required: true
        }
    },
    messages: {        
        Notaria_IdO: "Seleccione Notaria.",
        nOtrTipoO: "Seleccione ciudad.",
        sGarNroNotariaO: {
            required: "Ingrese numero de garantia notaria.",
            digits: "Ingrese solo numeros."
        },
        dGarFechaO: "Ingrese fecha.",
        nOtrMontoGarantizadoO: {
            required: "Ingrese valor del bien.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarFinancimientoO: {
            required: "Ingrese financiamiento.",
            decimales: "Permitido solo decimales o numeros enteros."
        },
        dGarValorAfectacionO: {
            required: "Ingrese valor de afectacion.",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarTipomonedaO: "Seleccione tipo de moneda.",
        dGarValorConvecionalO: {
            required: "Ingrese valor convesional",
            decimales: "Permetido solo decimales o numeros enteros."
        },
        nGarEstadoO: "Seleccione estado.",
    }
});

$("#FrmNotaria").validate({
    errorClass: 'error',
    rules: {        
        sNotNombre: {            
           required: true
        },
        nNotTelefono: {
           required: true
        },
        sNotDireccion: {
           required: true
        },
        nNotEstado: {
           required: true
        }
    },
    messages: {        
        sNotNombre: "Ingrese Nombres",
        nNotTelefono: "Ingrese Telefonos",
        sNotDireccion: "Ingrese Direccion",
        nNotEstado: "Por favor seleccione estado."
    }
});
$("#FrmVendedor").validate({
    errorClass: 'error',
    rules: {        
        nVenDNI: {            
           required: true
        },
        sVenNombres: {
           required: true
        },
        sVenApellidoPaterno: {
           required: true
        },
        sVenApellidoMaterno: {
           required: true
        },
        sVenTelefono: {
           required: true
        },
        nVenCorreo: {
           required: true
        },
        sVenDomicilio: {
           required: true
        },
        nVenEstado: {
           required: true
        }
    },
    messages: {        
        nVenDNI: "Ingrese DNI",
        sVenNombres: "Ingrese nombre",
        sVenApellidoPaterno: "Ingrese Apellido Paterno.",
        sVenApellidoMaterno: "Ingrese Apellido Materno.",
        sVenTelefono: "Ingrese telefono.",
        nVenCorreo: "Ingrese correo",
        sVenDomicilio: "Ingrese domicilio",
        nVenEstado: "seleccione estado."
    }
});
$("#FrmUsuario").validate({
    errorClass: 'error',
    rules: {        
        nombre: {            
           required: true,
           letras: true
        },
        login: {
           required: true
        },
        contraseñaOne: {
           required: true,
           password_modasa: true
        },
        contraseñaTwo: {
           required: true,
           equalTo: "#contraseñaOne",
           password_modasa: true
        },
        tipo: {
           required: true
        },
        estado: {
           required: true
        }
    },
    messages: {        
        nombre: "Ingrese nombre valido solo letras.",
        login: "Ingrese login porfavor.",
        contraseñaOne: {
            required: "Ingrese contraseña que utilizara.",
            password_modasa: "Constraseña no segura tener en cuenta (Letras, números, caracteres especiales y longitud entre 6 – 8 caracteres)"
        },
        contraseñaTwo: {
            required: "Por favor ingrese nuevamente la contraseña.",
            equalTo: "Las contraseñas no coinciden",
            password_modasa: "Constraseña no segura tener en cuenta (Letras, números, caracteres especiales y longitud entre 6 – 8 caracteres)"
        },
        tipo: "seleccione el tipo de usuario.",
        estado: "seleccione estado"
    }
});
$('#FrmFinancimiento').validate({ // initialize the plugin
    ignore: [],
    rules: {
        Cliente_Id: {
            required: true
        },
        Vendedor_Id: {
            required: true
        },
//        nFinAnio: {
//            required: true,
//            digits: true
//        },
//        dFinGravamen: {
//            required: true,
//            digits: true
//        },
        nFinEstado: {
            required: true
        }
    },
    messages: {        
        Cliente_Id: "<small class='selectpicker_items'>* Ingrese nombre valido solo letras.</small>",
        Vendedor_Id: "<small class='selectpicker_items'>* Ingrese nombre valido solo letras.</small>",
//        nFinAnio: "<small class='selectpicker_items'>* Ingrese nombre valido solo numeros.</small>",
//        dFinGravamen: "<small class='selectpicker_items'>Ingrese nombre valido solo letras.</small>",
        nFinEstado: "<small class='selectpicker_items'>Ingrese nombre valido solo letras.</small>"
    },
    submitHandler: function (form) { // for demo
//        alert('valid form submitted'); // for demo
        return true; // for demo
    }
});


//jQuery.validator.setDefaults({
//  debug: true,
//  success: "valid"
//});
//var form = $( "#FrmComposicionFamiliar" );
//form.validate();
//$( "#Agregar" ).click(function() {
//  alert( "Valid: " + form.valid() );
//});



$("#FrmProtocologe").validate({
    errorClass: 'error',
    rules: {        
        pro_numero_one: {            
           required: true
        },
        pro_numero_two: {
           required: true
        }
    },
    messages: {        
        pro_numero_one: "",
        pro_numero_two: "Ingrese nombre"
    }
});